
***********************************************
**** 4.6.do
***********************************************
**** This do file that examines a few matching 
**** and linear regression. 
***********************************************

set seed 123456789
clear
loc y10=4
loc y11=1.5
loc y12=-1.5
loc y13=1.2
loc y14=2.4
loc y15=3
loc y00=2
loc y01=1.5
loc y02=-1.5
loc y03=1.2
loc y04=2.4
loc y05=3
loc c0=1
loc c1=-.35
loc c2=.15
loc c3=-.25
loc c4=-1
loc c5=-.5
set obs 5000
g epsilony=invnorm(uniform())
g epsilonc=invnorm(uniform())
g x_0=1
loc i=1
while (`i'<6){
g x_`i'=invnorm(uniform())
loc i=`i'+1
}
g y0=5*epsilony
g y1=5*epsilony
g c=5*epsilonc
loc j=0
while (`j'<6){
replace y0=y0+`y0`j''*x_`j'
replace y1=y1+`y1`j''*x_`j'
replace c=c+`c`j''*x_`j'
loc j=`j'+1
}

g P=(y1-y0-c>0)
ta P
by P, sort: sum y1 y0 c x* epsilon*

sum P

sum P


by P, sort: sum epsilony epsilonc x_1 x_2 x_3 x_4 x_5 y0 y1

g TE=y1-y0
su TE
loc ATE=r(mean)
su TE if P==1
g Y=P*y1+(1-P)*y0
su Y y1 if P==1
loc ATE1=r(mean)
su Y y0 if P==0
loc ATE0=r(mean)
loc ATEnaive1=`ATE1'-`ATE0'
di `ATEnaive1'

reg Y P

loc ATEnaive2=_b[P]
di `ATEnaive2'

logit P x_1 x_2 x_3 x_4 x_5
predict PS
by P, sort: su PS


reg Y P x_1 x_2 x_3 x_4 x_5

reg Y P PS

g w1=1/PS
reg Y P [pweight=w1]

g wght=(Y*P)/PS -(Y*(1-P))/(1-PS)
su wght

teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5)
teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5), nn(7)


reg Y P

reg Y P x_1 x_2 x_3

logit P x_1 x_2 x_3 

predict PS1

reg Y P PS1

g wght1=(Y*P)/PS1 -(Y*(1-P))/(1-PS1)

su wght1


teffects psmatch (Y) (P x_1 x_2 x_3 )

teffects psmatch (Y) (P x_1 x_2 x_3 ), nn(1)

teffects psmatch (Y) (P x_1 x_2 x_3 ), nn(7)

clear

set seed 123456789
clear
loc y10=4
loc y11=1.5
loc y12=-1.5
loc y13=1.2
loc y14=2.4
loc y15=3
loc y11_i=1.9
loc y12_i=-1.5
loc y13_i=1
loc y14_i=1.7
loc y15_i=-2
loc y00=2
loc y01=1.5
loc y02=-1.5
loc y03=1.2
loc y04=2.4
loc y05=3
loc c0=1
loc c1=.5
loc c2=.75
loc c3=-1.25
loc c4=-2
loc c5=3
set obs 5000
g epsilony=invnorm(uniform())
g epsilonc=invnorm(uniform())
g x_0=1
loc i=1
while (`i'<6){
g x_`i'=invnorm(uniform())
loc i=`i'+1
}
g y0=15*epsilony
g y1=15*epsilony
g c=10*epsilonc
loc j=0
while (`j'<6){
replace y0=y0+`y0`j''*x_`j'
if (`j'==0) replace y1=y1+`y1`j''*x_`j' 
if(`j'>0 ) replace y1=y1+`y1`j''*x_`j' + `y1`j'_i'*x_`j'
replace c=c+`c`j''*x_`j'
loc j=`j'+1
}

g P=(y1-y0-c>0)
ta P
by P, sort: su y1 y0 c x* epsilon*
g TE=y1-y0
su TE
loc ATE=r(mean)
su TE if P==1
g Y=P*y1+(1-P)*y0
su Y y1 if P==1
loc ATE1=r(mean)
su Y y0 if P==0
loc ATE0=r(mean)
loc ATEnaive1=`ATE1'-`ATE0'
di `ATEnaive1'

reg Y P
loc ATEnaive2=_b[P]
di `ATEnaive2'

logit P x_1 x_2 x_3 x_4 x_5
predict PS
by P, sort: su PS



reg Y P x_1 x_2 x_3 x_4 x_5

reg Y P PS

g w1=1/PS

reg Y P [pweight=w1]

loc j=1
while (`j'<6){
g P_x_`j'=P*x_`j'
loc j=`j'+1
}

reg Y P P_x_1 P_x_2 P_x_3 P_x_4 P_x_5 x_1 x_2 x_3 x_4 x_5

g Pt=P

replace P=0
loc j=1
while (`j'<6){
replace P_x_`j'=0
loc j=`j'+1
}
predict Y_0

replace P=1

loc j=1
while (`j'<6){
replace P_x_`j'=x_`j'
loc j=`j'+1
}

predict Y_1

g ATEreg=Y_1-Y_0

su ATEreg

replace P=Pt

loc j=1
while (`j'<6){
replace P_x_`j'=Pt*x_`j'
loc j=`j'+1
}

g wght=(Y*P)/PS -(Y*(1-P))/(1-PS)

su wght

teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5)

teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5), nn(1)

teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5), nn(7)

reg Y P

reg Y P x_1 x_2 x_3

logit P x_1 x_2 x_3 

predict PS1

reg Y P PS1

g wght1=(Y*P)/PS1 -(Y*(1-P))/(1-PS1)

su wght1


teffects psmatch (Y) (P x_1 x_2 x_3)

teffects psmatch (Y) (P x_1 x_2 x_3), nn(1)

teffects psmatch (Y) (P x_1 x_2 x_3), nn(7)


clear

set seed 123456789
clear
loc y10=4
loc y11=1.5
loc y12=-1.5
loc y13=1.2
loc y14=2.4
loc y15=3
loc y11_i=9.9
loc y12_i=3.9
loc y13_i=5.2
loc y14_i=3.7
loc y15_i=4.8
loc y00=2
loc y01=1.5
loc y02=-1.5
loc y03=1.2
loc y04=2.4
loc y05=3
loc c0=25
loc c1=1.5
loc c2=3.0
loc c3=2.2
loc c4=1.5
loc c5=1
set obs 5000
g epsilony=invnorm(uniform())
g epsilonc=invnorm(uniform())
g x_0=1
/*
loc i=1
while (`i'<6){
g x_`i'=invnorm(uniform())
loc i=`i'+1
}
*/

loc ac=.7

 matrix C = (1, `ac', `ac', `ac', `ac'  \ ///
            `ac', 1, `ac',  `ac', `ac' \ ///
			`ac', `ac', 1, `ac', `ac' \ ///
			`ac', `ac', `ac', 1, `ac' \ ///
			`ac', `ac', `ac', `ac', 1)
 drawnorm x_1 x_2 x_3 x_4 x_5,  corr(C)
corr x_1 x_2 x_3 x_4 x_5
su x_*
g mu=uniform()
su mu
su x_* if mu>.5
su x_* if mu<.5
loc i=1
while (`i'<6){
replace x_`i'=2*x_`i'
replace x_`i'=x_`i'+6 if mu<.5
replace x_`i'=x_`i'+14 if mu>.5
loc i=`i'+1
}
su x_*
su x_* if mu>.5
su x_* if mu<.5
corr x_1 x_2 x_3 x_4 x_5

g y0=15*epsilony
g y1=15*epsilony
g c=6*epsilonc
loc j=0
while (`j'<6){
replace y0=y0+`y0`j''*x_`j'
if (`j'==0) replace y1=y1+`y1`j''*x_`j' 
if (`j'==1) replace y1=y1+`y1`j''*x_`j' + `y1`j'_i'*x_`j'
if (`j'==1) replace c=c+`c`j''*x_`j'
loc j=`j'+1
}

g P=(y1-y0-c>0)
ta P
by P, sort: su y1 y0 c x* epsilon*
g TE=y1-y0
su TE
loc ATE=r(mean)
su TE if P==1
g Y=P*y1+(1-P)*y0
su Y y1 if P==1
loc ATE1=r(mean)
su Y y0 if P==0
loc ATE0=r(mean)
loc ATEnaive1=`ATE1'-`ATE0'
di `ATEnaive1'

reg Y P
loc ATEnaive2=_b[P]
di `ATEnaive2'

* logit P x_1 x_2 x_3 x_4 x_5
logit P x_1 
predict PS
by P, sort: su PS



reg Y P x_1 x_2 x_3 x_4 x_5

reg Y P PS

g w1=1/PS

reg Y P [pweight=w1]

loc j=1
while (`j'<6){
g P_x_`j'=P*x_`j'
loc j=`j'+1
}

reg Y P P_x_1 P_x_2 P_x_3 P_x_4 P_x_5 x_1 x_2 x_3 x_4 x_5

g Pt=P

replace P=0
loc j=1
while (`j'<6){
replace P_x_`j'=0
loc j=`j'+1
}
predict Y_0

replace P=1

loc j=1
while (`j'<6){
replace P_x_`j'=x_`j'
loc j=`j'+1
}

predict Y_1

g ATEreg=Y_1-Y_0

su ATEreg

replace P=Pt

loc j=1
while (`j'<6){
replace P_x_`j'=Pt*x_`j'
loc j=`j'+1
}

g wght=(Y*P)/PS -(Y*(1-P))/(1-PS)

su wght

teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5), pstolerance(0)


teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5), nn(1)

teffects psmatch (Y) (P x_1 x_2 x_3 x_4 x_5), nn(7)

reg Y P

reg Y P x_1 x_2 x_3

logit P x_1 x_2 x_3 

predict PS1

reg Y P PS1

g wght1=(Y*P)/PS1 -(Y*(1-P))/(1-PS1)

su wght1


teffects psmatch (Y) (P x_1 x_2 x_3)


teffects psmatch (Y) (P x_1 x_2 x_3), nn(7)


clear

set obs 5000
g x=uniform()
g mu=uniform()
replace x=x-.6 if mu>.5
su x
su x if mu<.5
su x if mu>.5
g ey=invnorm(uniform())
g ec=uniform()
g y1=2+1.5*x+ey
g y0=1+.5*x+ey
g c=1+.3*ec
g P=(y1-y0-c>0)
ta P
by P, sort: su x
logit P x
predict PS
su PS if P==0
loc a=r(max)
su PS if P==1
loc b=r(min)
g TE=y1-y0
su TE
su TE if PS<`a'&PS>`b'

