***********************************************
**** 6.5.do
***********************************************
**** This do file illustrates the some extensions
**** to the sharp discontinuity design
***********************************************

clear
set seed 123456789
set obs 10000
g x=invnorm(uniform())
g x2=x*x
g x3=x2*x
g mu=invnorm(uniform())
g elig=(x<=0)
g ey=invnorm(uniform())
g y1=13+2.5*x+2*x2-2*x3+mu+ey
g y0=2+2.5*x+2*x2-2*x3+mu+ey
g ATE=y1-y0
su ATE
g ec=invnorm(uniform())
g C=1+100*(1-elig)-1.5*x - mu + ec
g Ct=1-2*x - mu + ec
g ret=y1-y0-Ct
su ret
g P=(y1-y0-C>0)
ta P
by elig, sort: ta P
g Y=P*y1+(1-P)*y0
reg Y P
reg Y P x



* basic regression of Y on P and x

reg Y P x


* basic regression of Y on P and x, x2, x3

reg Y P x x2 x3

